<?php

namespace App\Http\Controllers;

use App\Models\CampaignContext;
use App\Models\CampaignContextProduct;
use App\Models\Product;
use App\Models\Category;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    public function categories()
    {
        $categories = Category::all();
        return response()->json(['success' => true, 'message' => 'all categories', 'data' => $categories]);
    }

    public function brandCategories($brand_id)
    {
        $brands = Category::where('brand_id', $brand_id)->get();
        return response()->json(['success' => true, 'message' => 'brand categories', 'data' => $brands]);
    }

       public function categoryProducts($categoryId)
    {
        $products = optional(CampaignContext::where('category_id', $categoryId)->first())
            ->products()
            ?->with(['brand', 'images'])
            ->paginate(10) ?? collect();
        return response()->json(['success' => true, 'message' => 'category products', 'data' => $products]);
    }
}
