<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class CampaignContext extends Model
{
    use HasFactory;

    public function campaign()
    {
        return $this->belongsTo(Campaign::class);
    }

    public function brand()
    {
        return $this->belongsTo(Brand::class);
    }

    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function products()
    {
        return $this->belongsToMany(Product::class, 'campaign_context_products');
    }

    // Global Campaigns Scope
    public function scopeGlobal($query)
    {
        return $query->where('is_global', true);
    }

    // Campaigns filtered by brand and category
    public function scopeByCategoryAndBrand($query, $categoryId, $brandId)
    {
        return $query->where('category_id', $categoryId)
            ->where('brand_id', $brandId);
    }
}
